#!/bin/bash
echo "------ Top level build SHELL script ------"
echo " Options:"
echo "   clean:  Clean the build files from make"
echo "   uninstall: Clean installed executables and libraries from make install"
echo "   make: Generate the Makefile and do make"
echo "   test: Generate the Makefile and do make and make test"
echo "   install: Generate the Makefile and do make and make install"

if [ $# -ge 1 ]
then
  if [ $1 = "clean" ] 
  then
    echo "Cleaning cmake residuals and logs"
    if [ -e ./build/Makefile ]
    then
      cd ./build/; make clean; cd - 1>/dev/null
      if [ "$1" = "uninstall" ] 
      then
        cd ./build/; make uninstall; cd - 1>/dev/null
      fi
    fi
    rm -rf build/
    exit 0
  elif [ $1 = "make" ] || [ $1 = "test" ] || [ "$1" = "install" ] 
  then
    :
  else
    echo "Command not found"
    exit 1
  fi
fi
echo "Doing a regular cmake setup for making"

if [ ! -d ./build/ ] 
then
  mkdir ./build/
fi
cd ./build/; cmake ..; make

if [ "$1" = "test" ] 
then
  make test
elif [ "$1" = "install" ]
then
  make install
fi
cd - 1>/dev/null
